// ------------------------------------------------------------------
// time24.h
// written by:    [PUT YOUR NAME HERE]
// last modified: [PUT THE DUE DATE HERE]
//
// Description:
// [Add a short description of what is in this file]
// [Example: This file implements the time24 class functions as
//           declared in ... ]
//
// ------------------------------------------------------------------

#include <iostream>
#include <iomanip>
#include "time24.h"

using namespace std;

// ------------------------------------------------------------------
// Function: normalizeTime
// sets m_minute and m_hour within their proper ranges
// ------------------------------------------------------------------
void  time24::normalizeTime()
{
   int extraHours = m_minute / 60;  // integer division truncates decimal off

   // set m_minute in range 0 to 59
   m_minute %= 60;

   // update hour. set in range 0 to 23
   m_hour = (m_hour + extraHours) % 24;
}

// Task 2 look here
// ------------------------------------------------------------------
// Function: constructor
// initializes time data
//
// Aside:
// The " : m_hour(h), m_minute(m) " part of the below can be
// referred to as the "initialization list"
// This should not be confused with the default values that may
// be specified in the function's prototype in the header file.
// ------------------------------------------------------------------
time24::time24(int h, int m) : m_hour(h), m_minute(m)
{
   // Task 2 will need to delete some code above and add some code here
   
   // put m_hour and m_minute in correct range
   normalizeTime();
}

// ------------------------------------------------------------------
// Function: addTime
// add m minutes to the time
// ------------------------------------------------------------------
void time24::addTime(int m)
{
   // add m to m_minute. m_minute may exceed 59, so normalize
   m_minute += m;
   normalizeTime();
}

// Task 4 insert method here (be sure to modify header file too)
// ------------------------------------------------------------------
// Function: subtractHour
// [WRITE DESCRIPTION HERE]
// ------------------------------------------------------------------
// Delete this line and write the function here



// ------------------------------------------------------------------
// Function: duration
// ------------------------------------------------------------------
time24 time24::duration(const time24& t)
{
   // convert current time and time t to minutes
   int currTime = m_hour * 60 + m_minute;
   int tTime = t.m_hour * 60 + t.m_minute;

   // if t is earlier than the current time, throw an exception
   if (tTime < currTime)
   {
      // Be sure da_except.h is included, else rangeError will be undefined
      throw rangeError("time24 duration(): argument is an earlier time");
   }
   else
   {
      // create an anonymous object as the return value
      return time24(0, tTime-currTime);
   }
}

// ------------------------------------------------------------------
// Function: readTime
// ------------------------------------------------------------------
void time24::readTime()
{
   char colonSeparator;   // what a pain in the butt

   cin >> m_hour >> colonSeparator >> m_minute;
   // make sure m_hour and m_minute are in range
   normalizeTime();
}

// ------------------------------------------------------------------
// Function: writeTime
// output time in the format <m_hour>:<m_minute>
// This does NOT put a newline at the end of the output
// ------------------------------------------------------------------
void time24::writeTime() const
{
   // the implementation uses stream handling functions
   // not discussed in the book. consult your compiler
   // help system for details

   // save current format flags and fill character
   ios_base::fmtflags currentFlags = cout.flags();
   char currentFill = cout.fill();

   // set fill char to ' ' and enable right justification
   cout.fill(' ');
   cout.setf(ios::right,ios::adjustfield);

   // output the m_hour
   cout << setw(2) << m_hour << ':';

   // set fill char to '0' and output the m_minute
   cout.fill('0');
   cout << setw(2) << m_minute << "  ";

   // restore the fill char and the format flags
   cout.fill(currentFill);
   cout.setf(currentFlags);
}

// ------------------------------------------------------------------
// Function: getHour
// returns value of member variable: m_hour
// ------------------------------------------------------------------
int time24::getHour() const
{
   return m_hour;
}

// ------------------------------------------------------------------
// Function: getMinute
// returns value of member variable: m_minute
// ------------------------------------------------------------------
int time24::getMinute() const
{
   return m_minute;
}


// ------------------------------------------------------------------
// ------------------------------------------------------------------
// ------------------------------------------------------------------
// Operator Overloads and Friend Function Follow


// ------------------------------------------------------------------
// compare hours and minutes
// ------------------------------------------------------------------
bool operator== (const time24& lhs, const time24& rhs)
{
   return lhs.m_hour == rhs.m_hour && lhs.m_minute == rhs.m_minute;
}

// ------------------------------------------------------------------
// convert the m_hour and m_minute values for each operand to
// minutes. compare lhs in minutes with rhs in minutes
// ------------------------------------------------------------------
bool operator<  (const time24& lhs, const time24& rhs)
{
   return (lhs.m_hour*60 + lhs.m_minute) < (rhs.m_hour*60 + rhs.m_minute);
}

// Task 7 should insert code here
// Use the above code for the less than operator to start from
// ------------------------------------------------------------------
// [delete this line, begin function here, adjust above comments]

// ------------------------------------------------------------------
// create an anonymous object with m_hour = lhs.m_hour + rhs.m_hour
// and m_minute = lhs.m_minute+rhs.m_minute.
// ------------------------------------------------------------------
time24 operator+ (const time24& lhs, const time24& rhs)
{
   return time24(lhs.m_hour+rhs.m_hour, lhs.m_minute+rhs.m_minute);
}

// ------------------------------------------------------------------
// create an anonymous object with m_hour = lhs.m_hour and
// m_minute = lhs.m_minute + min.
// ------------------------------------------------------------------
time24 operator+ (const time24& lhs, int min){
   return time24(lhs.m_hour, lhs.m_minute + min);
}

// ------------------------------------------------------------------
// return the value rhs + min that is computed by
//    time24 operator+ (const time24& lhs, int min)
// ------------------------------------------------------------------
time24 operator+ (int min, const time24& rhs)
{
   return rhs + min;
}

// ------------------------------------------------------------------
// using the < operator, check whether lhs < rhs is true. if so
// terminate; otherwise return a time24 result built
// using the constructor
// ------------------------------------------------------------------
time24 operator- (const time24& lhs, const time24& rhs)
{
   if (lhs < rhs)
      throw rangeError("time24 operator-: Cannot subtract later from earlier time");

   // convert each object to minutes and compute the
   // difference in minutes. return the time24 object
   // having 0 as hours and the value of the difference
   // as minutes
   return time24(0, (lhs.m_hour*60 + lhs.m_minute) -
                    (rhs.m_hour*60 + rhs.m_minute));
}

// ------------------------------------------------------------------
// implement += by using addition with operands *this and rhs
// ------------------------------------------------------------------
time24& time24::operator+= (const time24& rhs)
{
   // add *this and rhs using overloaded + operator
   *this = *this + rhs;

   // return a reference to the current object
   return *this;
}

// ------------------------------------------------------------------
// implement += by using addition with operands *this and min
// ------------------------------------------------------------------
time24& time24::operator+= (int min)
{
   // add *this and min using overloaded + operator
   *this = *this + min;

   // return a reference to the current object
   return *this;
}

// ------------------------------------------------------------------
// overload stream operator >>. input has the form
//   m_hour:m_minute
// ------------------------------------------------------------------
istream& operator>> (istream& istr, time24& t)
{
   char separatorChar;

   istr >> t.m_hour >> separatorChar >> t.m_minute;
   // make sure m_hour and m_minute are in range
   t.normalizeTime();

   // return the stream
   return istr;
}

// ------------------------------------------------------------------
// overload stream operator <<. output in the form
//   m_hour:m_minute
// ------------------------------------------------------------------
ostream& operator<< (ostream& ostr, const time24& t)
{
   // the implementation uses stream handling functions
   // not discussed in the book. consult your compiler
   // help system for details

   // save current format flags and fill character
   ios_base::fmtflags currentFlags = ostr.flags();
   char currentFill = ostr.fill();

   // set fill char to ' ' and enable right justification
   ostr.fill(' ');
   ostr.setf(ios::right,ios::adjustfield);

   // output the m_hour
   ostr << setw(2) << t.m_hour << ':';

   // set fill char to '0' and output the m_minute
   ostr.fill('0');
   ostr << setw(2) << t.m_minute;

   // restore the fill char and the format flags
   ostr.fill(currentFill);
   ostr.setf(currentFlags);

   return ostr;
}

// End of File
