// ------------------------------------------------------------------
// time24.h
// written by:    [PUT YOUR NAME HERE]
// last modified: [PUT THE DUE DATE HERE]
//
// Description:
// [Add a short description of what is in this file and what it does]
//
// ------------------------------------------------------------------

#pragma once        // This prevents recursive and multiple inclusion 
                    // of this file. #pragma once is now supported by 
                    // most compilers and is a little cleaner than 
                    // using #ifndef BLAH, #define BLAH, #endif
                    // But you will find both techniques still used

#include "da_except.h"  // Needed for implementation of time24::duration function

using namespace std;

class time24
{
   // --------------------------------------------------------------
   // Public member variables follow
   // --------------------------------------------------------------
   public:
   // --- Currently no public member variables


   // --------------------------------------------------------------
   // Public member functions follow
   // --------------------------------------------------------------
   public:
      time24(int h = 0, int m = 0);
         // constructor initializes hour and minute
         // the default time is 0:00

      void addTime(int m);
         // update time by adding m minutes to the current time
         // Precondition:  m must be >= 0
         // Postcondition: The new time is m minutes later

      // Task 4 insert function prototype here, remove this comment
      // add pre- and post- condition comments, and description comment


      time24 duration(const time24& t);
         // return the length of time from the current time to some later
         // time t as a time24 value
         // Precondition:  time t must not be earlier than the current time.
         // if it is, throw a rangeError exception

      void readTime();
         // input from the keyboard time in the form hh:mm
         // Postcondition: Assign value hh to hour and mm to minute and
         // adjust units to the proper range.

      void writeTime() const;
         // display on the screen the current time in the form hh:mm


      int getHour() const;
         // return the hour value for the current time
 
      int getMinute() const;
         // return the minute value for the current time


      // -----------------------------------------------------------
      // Operator declarations follow
      // -----------------------------------------------------------
      // THESE FUNCTIONS ARE DISCUSSED IN 
      // CHAPTER 2 ON OPERATOR OVERLOADING
      
      friend bool operator== (const time24& lhs, const time24& rhs);

      friend bool operator<  (const time24& lhs, const time24& rhs);

      friend time24 operator+ (const time24& lhs, const time24& rhs);
         // form and return lhs + rhs

      friend time24 operator+ (const time24& lhs, int min);
         // form and return lhs + min
         // Precondition:  min must be >= 0

      friend time24 operator+ (int min, const time24& rhs);
         // form and return min + rhs
         // Precondition:  min must be >= 0

      friend time24 operator- (const time24& lhs, const time24& rhs);
         // form and return lhs - rhs
         // Precondition: lhs >= rhs. if not, throw a rangeError exception

      time24& operator+= (const time24& rhs);
         // current object = current object + rhs
         // Postcondition: the time increases by the value of rhs

      time24& operator+= (int min);
          // current object = current object + min
          // Precondition:  min must be >= 0
          // Postcondition: the time increases by min minutes

      friend istream& operator>> (istream& istr, time24& t);
          // input t in the format hh:mm.
          // May omit the leading digit if hours or minutes < 10

      friend ostream& operator<< (ostream& ostr, const time24& t);
          // output t in the format hh:mm. always include two digits
          // for the minute (e.g. 15:07). hours before 12 use 1 digit
          // and precede the hour by a blank (e.g. " 7:15")

   // --------------------------------------------------------------
   // End of public interface
   // --------------------------------------------------------------
   
   
   // --------------------------------------------------------------
   // Private member variables follow
   // --------------------------------------------------------------
   private:
      int m_hour;     // m_ is used to denote class member variable
      int m_minute;   // it is not required, but can help in reading the code

   // --------------------------------------------------------------
   // Private member functions follow
   // --------------------------------------------------------------
   private:      
      void normalizeTime();
         // utility function sets the hour value in the range 0 to 23
         // and the minute value in the range 0 to 59

};
